import { defineComponent as b, inject as S, provide as k, onUnmounted as O } from "vue";
import { D as K, u as _, H as x, p as B, A as D, z as G, a as T } from "./resize-bus-BJO1V4ET.js";
import { $circleShapePromise as r } from "./keys.es.js";
import { a as A, g as M } from "./plugin-component-config-DXFKcbOi.js";
var m, u, f;
const V = /* @__PURE__ */ b({
  name: "circle-shape",
  __name: "circle-shape",
  props: {
    center: { default: void 0 },
    clickable: { type: Boolean, default: !0 },
    draggable: { type: Boolean, default: !1 },
    editable: { type: Boolean, default: !1 },
    fillColor: { default: void 0 },
    fillOpacity: { default: void 0 },
    radius: { default: void 0 },
    strokeColor: { default: void 0 },
    strokeOpacity: { default: void 0 },
    strokePosition: { default: ((f = (u = (m = globalThis == null ? void 0 : globalThis.google) == null ? void 0 : m.maps) == null ? void 0 : u.StrokePosition) == null ? void 0 : f.CENTER) || 0 },
    strokeWeight: { default: void 0 },
    visible: { type: Boolean, default: !0 },
    zIndex: { default: void 0 },
    circleKey: { default: void 0 },
    mapKey: { default: void 0 },
    options: { default: void 0 }
  },
  emits: ["center_changed", "click", "dblclick", "drag", "dragend", "dragstart", "mousedown", "mousemove", "mouseout", "mouseover", "mouseup", "radius_changed", "rightclick"],
  setup(v, { expose: g, emit: h }) {
    var c, p, t, d;
    const e = v, a = h, n = e.mapKey ? S(e.mapKey) : (p = (c = K("map-layer")) == null ? void 0 : c.exposed) == null ? void 0 : p.mapPromise;
    if (!n)
      throw new Error("The map promise was not built");
    const { promiseDeferred: l, promise: s } = _(e.circleKey ?? r);
    k(e.circleKey ?? r, s);
    const y = (d = (t = x()) == null ? void 0 : t.excludeEventsOnAllComponents) == null ? void 0 : d.call(t);
    return n.then(async (o) => {
      if (!o)
        throw new Error("The map instance is not defined");
      const P = {
        map: o,
        ...B(e),
        ...e.options
      }, { Circle: C } = await google.maps.importLibrary(
        "maps"
      ), i = new C(P), w = M("GmvCircle"), E = A(
        "GmvCircle",
        "auto"
      );
      if (D(
        w,
        i,
        a,
        e
      ), G(
        E,
        i,
        a,
        y
      ), !l.resolve)
        throw new Error("circlePromiseDeferred.resolve is undefined");
      l.resolve(i);
    }).catch((o) => {
      throw o;
    }), O(async () => {
      var o;
      (o = await s) == null || o.setMap(null), T(e.circleKey ?? r);
    }), g({ circleShapePromise: s }), () => {
    };
  }
});
export {
  V as _
};
