import { defineComponent as K, inject as O, provide as b, onBeforeUnmount as x, onUnmounted as M, onUpdated as _, openBlock as j, createElementBlock as D, renderSlot as G } from "vue";
import { D as B, u as S, H as U, p as A, A as F, z as I, a as T } from "./resize-bus-BJO1V4ET.js";
import { $clusterPromise as n } from "./keys.es.js";
import { g as V, a as W } from "./plugin-component-config-DXFKcbOi.js";
import { MarkerClusterer as i } from "@googlemaps/markerclusterer";
const J = /* @__PURE__ */ K({
  name: "cluster-icon",
  __name: "cluster-icon",
  props: {
    algorithm: { default: void 0 },
    markers: { default: void 0 },
    onClusterClick: { type: Function, default: void 0 },
    renderer: { default: void 0 },
    clusterKey: { default: void 0 },
    mapKey: { default: void 0 },
    options: { default: void 0 }
  },
  emits: ["clusteringbegin", "clusteringend", "click", "rightclick", "dblclick", "drag", "dragend", "dragstart", "mousedown", "mouseout", "mouseover", "mouseup"],
  setup(f, { expose: v, emit: g }) {
    var c, m, t, p;
    const r = f, a = g, l = r.mapKey ? O(r.mapKey) : (m = (c = B("map-layer")) == null ? void 0 : c.exposed) == null ? void 0 : m.mapPromise;
    if (!l)
      throw new Error("The map promise was not built");
    const { promiseDeferred: u, promise: o } = S(r.clusterKey ?? n);
    b(r.clusterKey ?? n, o);
    const C = (p = (t = U()) == null ? void 0 : t.excludeEventsOnAllComponents) == null ? void 0 : p.call(t);
    return l.then((e) => {
      if (!e)
        throw new Error("the map instance is not defined");
      const d = {
        map: e,
        ...A(r),
        ...r.options
      }, { markers: h, onClusterClick: y, renderer: w, algorithm: P } = d;
      if (!i && typeof i != "function")
        throw new Error(
          "MarkerClusterer is not installed! Import it or include it from https://cdnjs.cloudflare.com/ajax/libs/js-marker-clusterer/1.0.0/markerclusterer.js"
        );
      const s = new i({
        map: e,
        markers: h,
        onClusterClick: y,
        algorithm: P,
        renderer: w
      }), k = V("GmvCluster"), E = W(
        "GmvCluster",
        "auto"
      );
      if (F(
        k,
        s,
        a,
        r
      ), I(
        E,
        s,
        a,
        C
      ), !u.resolve)
        throw new Error("clusterPromiseDeferred.resolve is undefined");
      u.resolve(s);
    }).catch((e) => {
      throw e;
    }), x(async () => {
      var e;
      (e = await o) == null || e.clearMarkers();
    }), M(async () => {
      var e;
      (e = await o) == null || e.setMap(null), T(r.clusterKey ?? n);
    }), _(async () => {
      var e;
      (e = await o) == null || e.render();
    }), v({ clusterPromise: o }), (e, d) => (j(), D("div", null, [
      G(e.$slots, "default")
    ]));
  }
});
export {
  J as _
};
