import { defineComponent as w, inject as L, provide as C, watch as E, onUnmounted as K } from "vue";
import { D as O, u as _, H as x, p as D, A as b, z as G, a as M } from "./resize-bus-BJO1V4ET.js";
import { $heatmapLayerPromise as p } from "./keys.es.js";
import { g as H, a as A } from "./plugin-component-config-DXFKcbOi.js";
const U = /* @__PURE__ */ w({
  name: "heatmap-layer",
  __name: "heatmap-layer",
  props: {
    data: { default: void 0 },
    dissipating: { type: Boolean, default: void 0 },
    gradient: { default: void 0 },
    maxIntensity: { default: void 0 },
    opacity: { default: 0.6 },
    number: { default: void 0 },
    heatmapKey: { default: void 0 },
    mapKey: { default: void 0 },
    options: { default: void 0 }
  },
  emits: ["data_changed"],
  setup(u, { expose: c, emit: l }) {
    var y, f, o, h;
    const a = u, n = l, m = a.mapKey ? L(a.mapKey) : (f = (y = O("map-layer")) == null ? void 0 : y.exposed) == null ? void 0 : f.mapPromise;
    if (!m)
      throw new Error("The map promise was not built");
    const { promiseDeferred: d, promise: t } = _(a.heatmapKey ?? p);
    C(a.heatmapKey ?? p, t);
    const v = (h = (o = x()) == null ? void 0 : o.excludeEventsOnAllComponents) == null ? void 0 : h.call(o);
    return m.then(async (e) => {
      if (!e)
        throw new Error("the map instance is not defined");
      const r = {
        map: e,
        ...D(a),
        ...a.options
      }, { HeatmapLayer: s } = await google.maps.importLibrary(
        "visualization"
      ), i = new s(r), g = H("GmvHeatmapLayer"), P = A(
        "GmvHeatmapLayer",
        "auto"
      );
      if (b(
        g,
        i,
        n,
        a
      ), G(
        P,
        i,
        n,
        v
      ), !d.resolve)
        throw new Error("heatmapLayerPromiseDeferred.resolve is undefined");
      d.resolve(i);
    }).catch((e) => {
      throw e;
    }), E(
      () => a.data,
      async (e, r) => {
        const s = await t;
        s && e && e !== r && (s.setData(e), n("data_changed", e));
      }
    ), K(async () => {
      var e;
      (e = await t) == null || e.setMap(null), M(a.heatmapKey ?? p);
    }), c({ heatmapLayerPromise: t }), () => {
    };
  }
});
export {
  U as _
};
