import { defineComponent as w, inject as h, provide as K, onUnmounted as L } from "vue";
import { D as C, u as E, H as O, p as _, A as x, z as b, a as B } from "./resize-bus-BJO1V4ET.js";
import { $kmlLayerPromise as r } from "./keys.es.js";
import { g as D, a as G } from "./plugin-component-config-DXFKcbOi.js";
const W = /* @__PURE__ */ w({
  name: "kml-layer",
  __name: "kml-layer",
  props: {
    clickable: { type: Boolean, default: !0 },
    preserveViewport: { type: Boolean, default: !1 },
    screenOverlays: { type: Boolean, default: !0 },
    suppressInfoWindows: { type: Boolean },
    url: { default: void 0 },
    zIndex: { default: void 0 },
    kmlKey: { default: void 0 },
    mapKey: { default: void 0 },
    options: { default: void 0 }
  },
  emits: ["click", "defaultviewport_changed", "status_changed"],
  setup(u, { expose: y, emit: f }) {
    var p, l, t, d;
    const e = u, a = f, m = e.mapKey ? h(e.mapKey) : (l = (p = C("map-layer")) == null ? void 0 : p.exposed) == null ? void 0 : l.mapPromise;
    if (!m)
      throw new Error("The map promise was not built");
    const { promiseDeferred: i, promise: s } = E(e.kmlKey ?? r);
    K(e.kmlKey ?? r, s);
    const c = (d = (t = O()) == null ? void 0 : t.excludeEventsOnAllComponents) == null ? void 0 : d.call(t);
    return m.then(async (o) => {
      if (!o)
        throw new Error("the map instance is not defined");
      const v = {
        map: o,
        ..._(e),
        ...e.options
      }, { KmlLayer: k } = await google.maps.importLibrary(
        "maps"
      ), n = new k(v), g = D("GmvKmlLayer"), P = G("GmvKmlLayer", "auto");
      if (x(
        g,
        n,
        a,
        e
      ), b(
        P,
        n,
        a,
        c
      ), !i.resolve)
        throw new Error("kmlPromiseDeferred.resolve is undefined");
      i.resolve(n);
    }).catch((o) => {
      throw o;
    }), L(async () => {
      var o;
      (o = await s) == null || o.setMap(null), B(e.kmlKey ?? r);
    }), y({ kmlLayerPromise: s }), () => {
    };
  }
});
export {
  W as _
};
