import { defineComponent as G, useSlots as _, inject as A, provide as B, computed as S, onUnmounted as V, h as z } from "vue";
import { D as E, f as L, u as N, H as T, p as U, A as W, z as j, a as F } from "./resize-bus-BJO1V4ET.js";
import { $markerPromise as p } from "./keys.es.js";
import { g as H, a as $ } from "./plugin-component-config-DXFKcbOi.js";
const R = /* @__PURE__ */ G({
  name: "marker-icon",
  __name: "marker-icon",
  props: {
    collisionBehavior: { default: void 0 },
    content: { default: void 0 },
    gmpClickable: { type: Boolean, default: !0 },
    gmpDraggable: { type: Boolean, default: !1 },
    position: { default: void 0 },
    title: { default: void 0 },
    zIndex: { default: void 0 },
    markerKey: { default: void 0 },
    clusterKey: { default: void 0 },
    mapKey: { default: void 0 },
    options: { default: void 0 }
  },
  emits: ["click", "drag", "dragend", "dragstart", "gmp-click", "update:position"],
  setup(K, { expose: O, emit: b }) {
    var v, g, k, y, n, h, C;
    const r = K, s = b, t = _(), u = r.mapKey ? A(r.mapKey) : (g = (v = E("map-layer")) == null ? void 0 : v.exposed) == null ? void 0 : g.mapPromise;
    if (!u)
      throw new Error("The map promise was not built");
    const i = r.clusterKey ? L(r.clusterKey) : (y = (k = E("cluster-icon")) == null ? void 0 : k.exposed) == null ? void 0 : y.clusterPromise;
    let m;
    const { promiseDeferred: f, promise: d } = N(r.markerKey ?? p);
    B(r.markerKey ?? p, d);
    const M = (h = (n = T()) == null ? void 0 : n.excludeEventsOnAllComponents) == null ? void 0 : h.call(n);
    u.then(async (o) => {
      if (!o)
        throw new Error("the map instance is not defined");
      const P = {
        map: o,
        ...U(r),
        ...r.options
      };
      i && (P.map = void 0);
      const { AdvancedMarkerElement: w } = await google.maps.importLibrary(
        "marker"
      ), a = new w(P), x = H("GmvMarker"), D = $(
        "GmvMarker",
        "auto"
      );
      if (W(
        x,
        a,
        s,
        r
      ), j(
        D,
        a,
        s,
        M
      ), a.addListener("dragend", () => {
        const e = a.position;
        s("update:position", {
          lat: typeof (e == null ? void 0 : e.lat) == "number" ? e.lat : e == null ? void 0 : e.lat(),
          lng: typeof (e == null ? void 0 : e.lng) == "number" ? e.lng : e == null ? void 0 : e.lng()
        });
      }), i && i.then((e) => {
        e == null || e.addMarker(a), m = e;
      }).catch((e) => {
        console.error(e);
      }), !f.resolve)
        throw new Error("markerPromiseDeferred.resolve is undefined");
      f.resolve(a);
    }).catch((o) => {
      throw o;
    });
    const l = S({
      get: () => m,
      set: (o) => {
        m = o;
      }
    });
    V(async () => {
      const o = await d;
      if (!o) {
        console.error("the marker instance is not defined");
        return;
      }
      l.value && (l.value.removeMarker(o, !0), l.value = void 0), o.map = null, F(r.markerKey ?? p);
    });
    let c = z(
      "div",
      null,
      (C = t.default) == null ? void 0 : C.call(t)
    );
    return t.default && typeof t.default == "function" && t.default().length && t.default().length === 1 && (c = t.default()[0]), O({ VNodeMarkerIcon: c, markerPromise: d }), () => {
    };
  }
});
export {
  R as _
};
