import { defineComponent as L, inject as k, provide as x, watch as B, onUnmounted as K } from "vue";
import { D as A, u as D, H as G, p as W, A as T, z as M, a as z } from "./resize-bus-BJO1V4ET.js";
import { $polygonShapePromise as u } from "./keys.es.js";
import { g as F, a as H } from "./plugin-component-config-DXFKcbOi.js";
import { u as N } from "./shapes-helper-C5uTLdKa.js";
var P, _, w;
const q = /* @__PURE__ */ L({
  name: "polygon-shape",
  __name: "polygon-shape",
  props: {
    clickable: { type: Boolean, default: !0 },
    draggable: { type: Boolean, default: !1 },
    editable: { type: Boolean, default: !1 },
    fillColor: { default: void 0 },
    fillOpacity: { default: void 0 },
    geodesic: { type: Boolean, default: !1 },
    paths: { default: void 0 },
    strokeColor: { default: void 0 },
    strokeOpacity: { default: void 0 },
    strokePosition: { default: ((w = (_ = (P = globalThis == null ? void 0 : globalThis.google) == null ? void 0 : P.maps) == null ? void 0 : _.StrokePosition) == null ? void 0 : w.CENTER) || 0 },
    strokeWeight: { default: void 0 },
    visible: { type: Boolean, default: !0 },
    zIndex: { default: void 0 },
    deepWatch: { type: Boolean, default: !1 },
    polygonKey: { default: void 0 },
    mapKey: { default: void 0 },
    options: { default: void 0 }
  },
  emits: ["click", "contextmenu", "dblclick", "drag", "dragend", "dragstart", "mousedown", "mousemove", "mouseout", "mouseover", "mouseup", "paths_changed"],
  setup(E, { expose: C, emit: S }) {
    var f, y, m, v;
    const o = E, s = S, g = o.mapKey ? k(o.mapKey) : (y = (f = A("map-layer")) == null ? void 0 : f.exposed) == null ? void 0 : y.mapPromise;
    if (!g)
      throw new Error("The map promise was not built");
    const { promiseDeferred: c, promise: l } = D(o.polygonKey ?? u);
    x(o.polygonKey ?? u, l);
    const b = (v = (m = G()) == null ? void 0 : m.excludeEventsOnAllComponents) == null ? void 0 : v.call(m);
    g.then(async (t) => {
      if (!t)
        throw new Error("the map instance is not defined");
      const h = {
        map: t,
        ...W(o),
        ...o.options
      }, { Polygon: r } = await google.maps.importLibrary(
        "maps"
      ), e = new r(h), a = F("GmvPolygon"), d = H(
        "GmvPolygon",
        "auto"
      );
      if (T(
        a,
        e,
        s,
        o
      ), M(
        d,
        e,
        s,
        b
      ), !c.resolve)
        throw new Error("polygonPromiseDeferred.resolve is undefined");
      c.resolve(e);
    }).catch((t) => {
      throw t;
    });
    const { clearEvents: O, updatePathOrPaths: p } = N(), n = [];
    return B(
      () => o.paths,
      async (t, h) => {
        const r = await l;
        if (!r) {
          console.error("polygon was not defined");
          return;
        }
        if (o.paths && t && t !== h) {
          O(n), r.setPaths(t);
          const e = r.getPaths(), a = () => r.getPaths();
          for (let d = 0; d < e.getLength(); d += 1) {
            const i = e.getAt(d);
            n.push([
              i,
              i.addListener(
                "insert_at",
                p("paths_changed", a, s)
              )
            ]), n.push([
              i,
              i.addListener(
                "remove_at",
                p("paths_changed", a, s)
              )
            ]), n.push([
              i,
              i.addListener(
                "set_at",
                p("paths_changed", a, s)
              )
            ]);
          }
          n.push([
            e,
            e.addListener(
              "insert_at",
              p("paths_changed", a, s)
            )
          ]), n.push([
            e,
            e.addListener(
              "remove_at",
              p("paths_changed", a, s)
            )
          ]), n.push([
            e,
            e.addListener(
              "set_at",
              p("paths_changed", a, s)
            )
          ]);
        }
      },
      {
        deep: o.deepWatch,
        immediate: !0
      }
    ), K(async () => {
      var t;
      (t = await l) == null || t.setMap(null), z(o.polygonKey ?? u);
    }), C({ polygonShapePromise: l }), () => {
    };
  }
});
export {
  q as _
};
