import { defineComponent as E, inject as C, provide as S, watch as O, onUnmounted as x } from "vue";
import { D as B, u as K, H as k, p as D, A as G, z as L, a as W } from "./resize-bus-BJO1V4ET.js";
import { $polylineShapePromise as d } from "./keys.es.js";
import { g as A, a as M } from "./plugin-component-config-DXFKcbOi.js";
import { u as z } from "./shapes-helper-C5uTLdKa.js";
const I = /* @__PURE__ */ E({
  name: "polyline-shape",
  __name: "polyline-shape",
  props: {
    clickable: { type: Boolean, default: !0 },
    draggable: { type: Boolean, default: !1 },
    editable: { type: Boolean, default: !1 },
    geodesic: { type: Boolean, default: !1 },
    icons: { default: void 0 },
    path: { default: void 0 },
    strokeColor: { default: void 0 },
    strokeOpacity: { default: void 0 },
    strokeWeight: { default: void 0 },
    visible: { type: Boolean, default: !0 },
    zIndex: { default: void 0 },
    deepWatch: { type: Boolean, default: !1 },
    polylineKey: { default: void 0 },
    mapKey: { default: void 0 },
    options: { default: void 0 }
  },
  emits: ["click", "contextmenu", "dblclick", "drag", "dragend", "dragstart", "mousedown", "mousemove", "mouseout", "mouseover", "mouseup", "path_changed"],
  setup(y, { expose: g, emit: v }) {
    var c, h, p, f;
    const e = y, a = v, m = e.mapKey ? C(e.mapKey) : (h = (c = B("map-layer")) == null ? void 0 : c.exposed) == null ? void 0 : h.mapPromise;
    if (!m)
      throw new Error("The map promise was not built");
    const { promiseDeferred: u, promise: s } = K(e.polylineKey ?? d);
    S(e.polylineKey ?? d, s);
    const P = (f = (p = k()) == null ? void 0 : p.excludeEventsOnAllComponents) == null ? void 0 : f.call(p);
    m.then(async (o) => {
      if (!o)
        throw new Error("the map instance is not defined");
      const l = {
        map: o,
        ...D(e),
        ...e.options
      }, { Polyline: t } = await google.maps.importLibrary(
        "maps"
      ), n = new t(l), b = A("GmvPolyline"), _ = M(
        "GmvPolyline",
        "auto"
      );
      if (G(
        b,
        n,
        a,
        e
      ), L(
        _,
        n,
        a,
        P
      ), !u.resolve)
        throw new Error("polylinePromiseDeferred.resolve is undefined");
      u.resolve(n);
    }).catch((o) => {
      throw o;
    });
    const { clearEvents: w, updatePathOrPaths: r } = z(), i = [];
    return O(
      () => e.path,
      async (o, l) => {
        const t = await s;
        if (!t) {
          console.error("polyline was not defined");
          return;
        }
        if (e.path && o && o !== l) {
          w(i), t.setPath(o);
          const n = t.getPath();
          i.push([
            n,
            n.addListener(
              "insert_at",
              r(
                "path_changed",
                t.getPath.bind(t),
                a
              )
            )
          ]), i.push([
            n,
            n.addListener(
              "remove_at",
              r(
                "path_changed",
                t.getPath.bind(t),
                a
              )
            )
          ]), i.push([
            n,
            n.addListener(
              "set_at",
              r(
                "path_changed",
                t.getPath.bind(t),
                a
              )
            )
          ]);
        }
      },
      { deep: e.deepWatch, immediate: !0 }
    ), x(async () => {
      var o;
      (o = await s) == null || o.setMap(null), W(e.polylineKey ?? d);
    }), g({ polylineShapePromise: s }), () => {
    };
  }
});
export {
  I as _
};
