import { defineComponent as E, inject as O, provide as S, onUnmounted as k } from "vue";
import { D as x, u as K, H as _, p as B, A as D, z as G, a as R } from "./resize-bus-BJO1V4ET.js";
import { $rectangleShapePromise as s } from "./keys.es.js";
import { g as T, a as A } from "./plugin-component-config-DXFKcbOi.js";
var c, u, g;
const N = /* @__PURE__ */ E({
  name: "rectangle-shape",
  __name: "rectangle-shape",
  props: {
    bounds: { default: void 0 },
    clickable: { type: Boolean, default: !0 },
    draggable: { type: Boolean, default: !1 },
    editable: { type: Boolean, default: !1 },
    fillColor: { default: void 0 },
    fillOpacity: { default: void 0 },
    strokeColor: { default: void 0 },
    strokeOpacity: { default: void 0 },
    strokePosition: { default: ((g = (u = (c = globalThis == null ? void 0 : globalThis.google) == null ? void 0 : c.maps) == null ? void 0 : u.StrokePosition) == null ? void 0 : g.CENTER) || 0 },
    strokeWeight: { default: void 0 },
    visible: { type: Boolean, default: !0 },
    zIndex: { default: void 0 },
    rectangleKey: { default: void 0 },
    mapKey: { default: void 0 },
    options: { default: void 0 }
  },
  emits: ["bounds_changed", "click", "contextmenu", "dblclick", "drag", "dragend", "dragstart", "mousedown", "mousemove", "mouseout", "mouseover", "mouseup"],
  setup(f, { expose: v, emit: h }) {
    var p, d, t, m;
    const e = f, r = h, i = e.mapKey ? O(e.mapKey) : (d = (p = x("map-layer")) == null ? void 0 : p.exposed) == null ? void 0 : d.mapPromise;
    if (!i)
      throw new Error("The map promise was not built");
    const { promiseDeferred: l, promise: n } = K(e.rectangleKey ?? s);
    S(e.rectangleKey ?? s, n);
    const y = (m = (t = _()) == null ? void 0 : t.excludeEventsOnAllComponents) == null ? void 0 : m.call(t);
    return i.then(async (o) => {
      if (!o)
        throw new Error("the map instance is not defined");
      const P = {
        map: o,
        ...B(e),
        ...e.options
      }, { Rectangle: b } = await google.maps.importLibrary(
        "maps"
      ), a = new b(P), w = T("GmvRectangle"), C = A(
        "GmvRectangle",
        "auto"
      );
      if (D(
        w,
        a,
        r,
        e
      ), G(
        C,
        a,
        r,
        y
      ), !l.resolve)
        throw new Error("rectanglePromiseDeferred.resolve is undefined");
      l.resolve(a);
    }).catch((o) => {
      throw o;
    }), k(async () => {
      var o;
      (o = await n) == null || o.setMap(null), R(e.rectangleKey ?? s);
    }), v({ rectangleShapePromise: n }), () => {
    };
  }
});
export {
  N as _
};
