declare function __VLS_template(): {
    slots: {
        default?(_: {
            deleteSelection: () => void;
            setDrawingMode: (mode: google.maps.drawing.OverlayType | null) => Promise<void>;
        }): any;
    };
    refs: {};
    attrs: Partial<{}>;
};
type __VLS_TemplateResult = ReturnType<typeof __VLS_template>;
declare const __VLS_component: import('vue').DefineComponent<{
    circleOptions?: google.maps.CircleOptions;
    drawingControl?: boolean;
    drawingControlOptions?: google.maps.drawing.DrawingControlOptions;
    drawingMode?: google.maps.drawing.OverlayType | null;
    markerOptions?: google.maps.marker.AdvancedMarkerElementOptions;
    polygonOptions?: google.maps.PolygonOptions;
    polylineOptions?: google.maps.PolylineOptions;
    rectangleOptions?: google.maps.RectangleOptions;
    position?: "TOP_CENTER" | "TOP_LEFT" | "TOP_RIGHT" | "LEFT_TOP" | "RIGHT_TOP" | "LEFT_CENTER" | "RIGHT_CENTER" | "LEFT_BOTTOM" | "RIGHT_BOTTOM" | "BOTTOM_CENTER" | "BOTTOM_LEFT" | "BOTTOM_RIGHT";
    drawingModes?: google.maps.drawing.OverlayType[];
    shapes?: google.maps.drawing.OverlayCompleteEvent[];
    drawingKey?: string;
    mapKey?: string;
    options?: Record<string, unknown>;
}, {
    setDrawingMode: (mode: google.maps.drawing.OverlayType | null) => Promise<void>;
    deleteSelection: () => void;
    clearAll: () => void;
    drawingManagerPromise: Promise<google.maps.drawing.DrawingManager | undefined>;
}, {}, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, {
    circlecomplete: (value: google.maps.Circle) => any;
    markercomplete: (value: google.maps.marker.AdvancedMarkerElement) => any;
    polygoncomplete: (value: google.maps.Polygon) => any;
    polylinecomplete: (value: google.maps.Polyline) => any;
    rectanglecomplete: (value: google.maps.Rectangle) => any;
    overlaycomplete: (value: google.maps.drawing.OverlayCompleteEvent) => any;
    "update:shapes": (value: google.maps.drawing.OverlayCompleteEvent[]) => any;
    "added:shape": (value: google.maps.drawing.OverlayCompleteEvent) => any;
    "removed:shape": (value: google.maps.drawing.OverlayCompleteEvent) => any;
}, string, import('vue').PublicProps, Readonly<{
    circleOptions?: google.maps.CircleOptions;
    drawingControl?: boolean;
    drawingControlOptions?: google.maps.drawing.DrawingControlOptions;
    drawingMode?: google.maps.drawing.OverlayType | null;
    markerOptions?: google.maps.marker.AdvancedMarkerElementOptions;
    polygonOptions?: google.maps.PolygonOptions;
    polylineOptions?: google.maps.PolylineOptions;
    rectangleOptions?: google.maps.RectangleOptions;
    position?: "TOP_CENTER" | "TOP_LEFT" | "TOP_RIGHT" | "LEFT_TOP" | "RIGHT_TOP" | "LEFT_CENTER" | "RIGHT_CENTER" | "LEFT_BOTTOM" | "RIGHT_BOTTOM" | "BOTTOM_CENTER" | "BOTTOM_LEFT" | "BOTTOM_RIGHT";
    drawingModes?: google.maps.drawing.OverlayType[];
    shapes?: google.maps.drawing.OverlayCompleteEvent[];
    drawingKey?: string;
    mapKey?: string;
    options?: Record<string, unknown>;
}> & Readonly<{
    onCirclecomplete?: ((value: google.maps.Circle) => any) | undefined;
    onMarkercomplete?: ((value: google.maps.marker.AdvancedMarkerElement) => any) | undefined;
    onPolygoncomplete?: ((value: google.maps.Polygon) => any) | undefined;
    onPolylinecomplete?: ((value: google.maps.Polyline) => any) | undefined;
    onRectanglecomplete?: ((value: google.maps.Rectangle) => any) | undefined;
    onOverlaycomplete?: ((value: google.maps.drawing.OverlayCompleteEvent) => any) | undefined;
    "onUpdate:shapes"?: ((value: google.maps.drawing.OverlayCompleteEvent[]) => any) | undefined;
    "onAdded:shape"?: ((value: google.maps.drawing.OverlayCompleteEvent) => any) | undefined;
    "onRemoved:shape"?: ((value: google.maps.drawing.OverlayCompleteEvent) => any) | undefined;
}>, {
    options: Record<string, unknown>;
    mapKey: string;
    circleOptions: google.maps.CircleOptions;
    drawingControl: boolean;
    drawingControlOptions: google.maps.drawing.DrawingControlOptions;
    drawingMode: google.maps.drawing.OverlayType | null;
    markerOptions: google.maps.marker.AdvancedMarkerElementOptions;
    polygonOptions: google.maps.PolygonOptions;
    polylineOptions: google.maps.PolylineOptions;
    rectangleOptions: google.maps.RectangleOptions;
    position: "TOP_CENTER" | "TOP_LEFT" | "TOP_RIGHT" | "LEFT_TOP" | "RIGHT_TOP" | "LEFT_CENTER" | "RIGHT_CENTER" | "LEFT_BOTTOM" | "RIGHT_BOTTOM" | "BOTTOM_CENTER" | "BOTTOM_LEFT" | "BOTTOM_RIGHT";
    drawingModes: google.maps.drawing.OverlayType[];
    shapes: google.maps.drawing.OverlayCompleteEvent[];
    drawingKey: string;
}, {}, {}, {}, string, import('vue').ComponentProvideOptions, false, {}, any>;
declare const _default: __VLS_WithTemplateSlots<typeof __VLS_component, __VLS_TemplateResult["slots"]>;
export default _default;
type __VLS_WithTemplateSlots<T, S> = T & {
    new (): {
        $slots: S;
    };
};
