/**
 * This method trigger the resize event of Google Maps
 * @method resize
 * @returns {void}
 * @public
 */
declare function resize(): Promise<void>;
/**
 * Preserve the previous center when resize the map
 * @method resizePreserveCenter
 * @returns {void}
 * @public
 */
declare function resizePreserveCenter(): Promise<void>;
declare function __VLS_template(): {
    slots: {
        default?(_: {}): any;
    };
    refs: {
        gmvStreetViewPanoramaRef: HTMLDivElement;
    };
    attrs: Partial<{}>;
};
type __VLS_TemplateResult = ReturnType<typeof __VLS_template>;
declare const __VLS_component: import('vue').DefineComponent<{
    addressControl?: boolean;
    addressControlOptions?: google.maps.StreetViewAddressControlOptions;
    clickToGo?: boolean;
    controlSize?: number;
    disableDefaultUI?: boolean;
    disableDoubleClickZoom?: boolean;
    enableCloseButton?: boolean;
    fullscreenControl?: boolean;
    fullscreenControlOptions?: google.maps.FullscreenControlOptions;
    imageDateControl?: boolean;
    linksControl?: boolean;
    motionTracking?: boolean;
    motionTrackingControl?: boolean;
    motionTrackingControlOptions?: google.maps.MotionTrackingControlOptions;
    panControl?: boolean;
    panControlOptions?: google.maps.PanControlOptions;
    pano?: string;
    position?: google.maps.LatLng | google.maps.LatLngLiteral;
    pov?: google.maps.StreetViewPov;
    scrollwheel?: boolean;
    showRoadLabels?: boolean;
    visible?: boolean;
    zoom?: number;
    zoomControl?: boolean;
    zoomControlOptions?: google.maps.ZoomControlOptions;
    streetViewKey?: string;
    options?: Record<string, unknown>;
}, {
    currentResizeBus: import('vue').Ref<import('mitt').Emitter<Record<import('mitt').EventType, unknown>> | undefined, import('mitt').Emitter<Record<import('mitt').EventType, unknown>> | undefined>;
    _resizeCallback: () => void;
    _delayedResizeCallback: () => void;
    resize: typeof resize;
    resizePreserveCenter: typeof resizePreserveCenter;
    streetViewPanoramaPromise: Promise<google.maps.StreetViewPanorama | undefined>;
    gmvStreetViewPanorama: Readonly<import('vue').ShallowRef<HTMLDivElement | null>>;
}, {}, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, {
    resize: () => any;
    closeclick: (value: Event) => any;
    position_changed: (value: google.maps.LatLng | null) => any;
    status_changed: () => any;
    zoom_changed: () => any;
    pano_changed: () => any;
    pov_changed: () => any;
    visible_changed: () => any;
}, string, import('vue').PublicProps, Readonly<{
    addressControl?: boolean;
    addressControlOptions?: google.maps.StreetViewAddressControlOptions;
    clickToGo?: boolean;
    controlSize?: number;
    disableDefaultUI?: boolean;
    disableDoubleClickZoom?: boolean;
    enableCloseButton?: boolean;
    fullscreenControl?: boolean;
    fullscreenControlOptions?: google.maps.FullscreenControlOptions;
    imageDateControl?: boolean;
    linksControl?: boolean;
    motionTracking?: boolean;
    motionTrackingControl?: boolean;
    motionTrackingControlOptions?: google.maps.MotionTrackingControlOptions;
    panControl?: boolean;
    panControlOptions?: google.maps.PanControlOptions;
    pano?: string;
    position?: google.maps.LatLng | google.maps.LatLngLiteral;
    pov?: google.maps.StreetViewPov;
    scrollwheel?: boolean;
    showRoadLabels?: boolean;
    visible?: boolean;
    zoom?: number;
    zoomControl?: boolean;
    zoomControlOptions?: google.maps.ZoomControlOptions;
    streetViewKey?: string;
    options?: Record<string, unknown>;
}> & Readonly<{
    onResize?: (() => any) | undefined;
    onCloseclick?: ((value: Event) => any) | undefined;
    onPosition_changed?: ((value: google.maps.LatLng | null) => any) | undefined;
    onStatus_changed?: (() => any) | undefined;
    onZoom_changed?: (() => any) | undefined;
    onPano_changed?: (() => any) | undefined;
    onPov_changed?: (() => any) | undefined;
    onVisible_changed?: (() => any) | undefined;
}>, {
    options: Record<string, unknown>;
    visible: boolean;
    position: google.maps.LatLng | google.maps.LatLngLiteral;
    controlSize: number;
    disableDoubleClickZoom: boolean;
    fullscreenControlOptions: google.maps.FullscreenControlOptions;
    scrollwheel: boolean;
    zoom: number;
    zoomControlOptions: google.maps.ZoomControlOptions;
    addressControlOptions: google.maps.StreetViewAddressControlOptions;
    clickToGo: boolean;
    enableCloseButton: boolean;
    motionTrackingControlOptions: google.maps.MotionTrackingControlOptions;
    panControlOptions: google.maps.PanControlOptions;
    pano: string;
    pov: google.maps.StreetViewPov;
    showRoadLabels: boolean;
    streetViewKey: string;
}, {}, {}, {}, string, import('vue').ComponentProvideOptions, false, {}, any>;
declare const _default: __VLS_WithTemplateSlots<typeof __VLS_component, __VLS_TemplateResult["slots"]>;
export default _default;
type __VLS_WithTemplateSlots<T, S> = T & {
    new (): {
        $slots: S;
    };
};
