import { IGmapVuePluginOptions } from '../interfaces';
import { TGlobalGoogleObject } from '../types';
/**
 * This function returns a promise when is resolved returns the original Google
 * Maps API. With this promise you can wait until the Google Maps API is fully
 * loaded.
 *
 * @public
 * @returns {Promise<any>}
 */
export declare function useGoogleMapsApiPromiseLazy(): Promise<TGlobalGoogleObject | undefined> | undefined;
/**
 * This function returns the configuration passed to the plugin
 *
 * @public
 * @returns IPluginOptions
 */
export declare function usePluginOptions(): IGmapVuePluginOptions | undefined;
