import { MarkerClusterer } from '@googlemaps/markerclusterer';
import { InjectionKey } from 'vue';
import { IGmapVuePluginOptions } from '../interfaces';
export declare const $recyclePrefix = "__gmc__";
export declare const $autocompletePromise: InjectionKey<Promise<google.maps.places.Autocomplete | undefined>>;
export declare const $mapPromise: InjectionKey<Promise<google.maps.Map | undefined>>;
export declare const $streetViewPanoramaPromise: InjectionKey<Promise<google.maps.StreetViewPanorama | undefined>>;
export declare const $clusterPromise: InjectionKey<Promise<MarkerClusterer | undefined>>;
export declare const $markerPromise: InjectionKey<Promise<google.maps.marker.AdvancedMarkerElement | undefined>>;
export declare const $infoWindowPromise: InjectionKey<Promise<google.maps.InfoWindow | undefined>>;
export declare const $kmlLayerPromise: InjectionKey<Promise<google.maps.KmlLayer | undefined>>;
export declare const $heatmapLayerPromise: InjectionKey<Promise<google.maps.visualization.HeatmapLayer | undefined>>;
export declare const $circleShapePromise: InjectionKey<Promise<google.maps.Circle | undefined>>;
export declare const $polygonShapePromise: InjectionKey<Promise<google.maps.Polygon | undefined>>;
export declare const $polylineShapePromise: InjectionKey<Promise<google.maps.Polyline | undefined>>;
export declare const $rectangleShapePromise: InjectionKey<Promise<google.maps.Rectangle | undefined>>;
export declare const $drawingManagerPromise: InjectionKey<Promise<google.maps.drawing.DrawingManager | undefined>>;
export declare const $gmapOptions: InjectionKey<IGmapVuePluginOptions | undefined>;
