import { defineComponent as P, useTemplateRef as w, provide as A, watch as C, onMounted as E, onUnmounted as R, openBlock as O, createElementBlock as G, renderSlot as F, createElementVNode as _, mergeProps as b } from "vue";
import { H as B, u as D, G as I, s as M, p as S, A as T, z as K, a as $ } from "./resize-bus-BJO1V4ET.js";
import { $autocompletePromise as i } from "./keys.es.js";
import { g as L, a as k } from "./plugin-component-config-DXFKcbOi.js";
const H = /* @__PURE__ */ P({
  inheritAttrs: !1,
  name: "autocomplete-input",
  __name: "autocomplete-input",
  props: {
    bounds: { default: void 0 },
    componentRestrictions: { default: void 0 },
    fields: { default: void 0 },
    strictBounds: { type: Boolean, default: void 0 },
    types: { default: void 0 },
    selectFirstOnEnter: { type: Boolean, default: !0 },
    slotRef: { default: void 0 },
    setFieldsTo: { default: void 0 },
    autocompleteKey: { default: void 0 },
    options: { default: void 0 }
  },
  emits: ["place_changed"],
  setup(c, { expose: d, emit: f }) {
    var n, u;
    const e = c, g = w(
      "gmvAutoCompleteInputRef"
    ), p = f, v = (u = (n = B()) == null ? void 0 : n.excludeEventsOnAllComponents) == null ? void 0 : u.call(n), { promiseDeferred: l, promise: a } = D(e.autocompleteKey ?? i);
    return A(e.autocompleteKey ?? i, a), C(
      () => e.componentRestrictions,
      async (o, t) => {
        const r = await a;
        if (!r) {
          console.error("the autocomplete instance is not defined");
          return;
        }
        o && o !== t && r.setComponentRestrictions(o);
      }
    ), E(() => {
      var o;
      (o = I()) == null || o.then(async () => {
        const t = e.slotRef ? e.slotRef : g.value;
        if (!t)
          throw new Error(
            "we can find the template ref: 'gmvAutoCompleteInput' or we can't use the slotRef prop"
          );
        e.selectFirstOnEnter && M(t);
        const r = {
          ...S(e),
          ...e.options
        }, { Autocomplete: m } = await google.maps.importLibrary(
          "places"
        );
        if (typeof m != "function")
          throw new Error(
            "google.maps.places.Autocomplete is undefined. Did you add 'places' to libraries when loading Google Maps?"
          );
        const s = new m(t, r), h = L("GmvAutocomplete"), y = k(
          "GmvAutocomplete",
          "auto"
        );
        if (T(
          h,
          s,
          p,
          e
        ), K(
          y,
          s,
          p,
          v
        ), e.setFieldsTo && s.setFields(e.setFieldsTo), s.addListener("place_changed", () => {
          p("place_changed", s.getPlace());
        }), !l.resolve)
          throw new Error("autocompletePromiseDeferred.resolve is undefined");
        l.resolve(s);
      }).catch((t) => {
        throw t;
      });
    }), R(() => {
      $(e.autocompleteKey ?? i);
    }), d({
      autocompletePromise: a
    }), (o, t) => (O(), G("div", null, [
      F(o.$slots, "default", { attrs: o.$attrs }, () => [
        _("input", b({ ref: "gmvAutoCompleteInputRef" }, o.$attrs), null, 16)
      ])
    ]));
  }
});
export {
  H as _
};
