import { defineComponent as I, useTemplateRef as M, inject as B, provide as D, computed as _, watch as f, onMounted as G, onUnmounted as A, openBlock as S, createElementBlock as z, createElementVNode as N, renderSlot as R } from "vue";
import { D as T, u as V, H as L, d as U, p as $, A as j, z as F, a as H } from "./resize-bus-BJO1V4ET.js";
import { $infoWindowPromise as c } from "./keys.es.js";
import { g as q, a as J } from "./plugin-component-config-DXFKcbOi.js";
const Q = { class: "info-window-container" }, X = {
  ref: "gmvInfoWindowRef",
  class: "info-window-content"
}, no = /* @__PURE__ */ I({
  name: "info-window",
  __name: "info-window",
  props: {
    ariaLabel: { default: void 0 },
    content: { default: void 0 },
    disableAutoPan: { type: Boolean, default: !1 },
    maxWidth: { default: void 0 },
    minWidth: { default: void 0 },
    pixelOffset: { default: void 0 },
    position: { default: void 0 },
    zIndex: { default: void 0 },
    opened: { type: Boolean, default: void 0 },
    marker: { default: void 0 },
    infoWindowKey: { default: void 0 },
    markerKey: { default: void 0 },
    mapKey: { default: void 0 },
    options: { default: void 0 }
  },
  emits: ["close", "closeclick", "content_changed", "domready", "position_changed", "visible", "zindex_changed"],
  setup(k, { expose: C, emit: E }) {
    var y, g, s, P;
    const e = k, m = M("gmvInfoWindowRef"), p = E, l = e.mapKey ? B(e.mapKey) : (g = (y = T("map-layer")) == null ? void 0 : y.exposed) == null ? void 0 : g.mapPromise;
    if (!l)
      throw new Error("The map promise was not built");
    const { promiseDeferred: w, promise: t } = V(e.infoWindowKey ?? c);
    D(e.infoWindowKey ?? c, t);
    const O = (P = (s = L()) == null ? void 0 : s.excludeEventsOnAllComponents) == null ? void 0 : P.call(s);
    let u, v;
    l.then(async (o) => {
      if (!o)
        throw new Error("the map instance is not defined");
      u = o;
      const n = U(e.markerKey), i = {
        map: o,
        ...$(e),
        ...e.options
      };
      n.then((d) => {
        v = d;
      }).catch((d) => {
        console.error(d);
      });
      const { InfoWindow: x } = await google.maps.importLibrary(
        "maps"
      ), a = new x({
        ...i,
        content: m.value
      }), K = q("GmvInfoWindow"), b = J(
        "GmvInfoWindow",
        "auto"
      );
      if (j(
        K,
        a,
        p,
        e
      ), F(
        b,
        a,
        p,
        O
      ), !w.resolve)
        throw new Error("infoWindowPromiseDeferred.resolve is undefined");
      w.resolve(a);
    }).then(() => W()).catch((o) => {
      throw o;
    });
    const r = _(() => u), h = _(() => v), W = async () => {
      const o = await t;
      if (!o) {
        console.error("the info window instance is not defined");
        return;
      }
      e.opened ? h.value ? o.open(r.value, h.value) : e.marker ? o.open(r.value, e.marker) : o.open(r.value) : o.close();
    };
    return f(
      () => e.opened,
      async () => {
        await W();
      }
    ), f(
      () => e.position,
      async (o, n) => {
        const i = await t;
        if (!i) {
          console.error("the info window is not defined");
          return;
        }
        o && o !== n && i.setPosition(o);
      }
    ), f(
      () => e.content,
      async (o, n) => {
        const i = await t;
        if (!i) {
          console.error("the info window is not defined");
          return;
        }
        o && o !== n && i.setContent(o);
      }
    ), G(() => {
      var n;
      const o = m.value;
      o && ((n = o.parentNode) == null || n.removeChild(o));
    }), A(async () => {
      var o;
      (o = await t) == null || o.close(), H(e.infoWindowKey ?? c);
    }), C({ infoWindowPromise: t }), (o, n) => (S(), z("div", Q, [
      N("div", X, [
        R(o.$slots, "default")
      ], 512)
    ]));
  }
});
export {
  no as _
};
