declare const _default: import('vue').DefineComponent<{
    center?: google.maps.LatLng | google.maps.LatLngLiteral;
    clickable?: boolean;
    draggable?: boolean;
    editable?: boolean;
    fillColor?: string;
    fillOpacity?: number;
    radius?: number;
    strokeColor?: string;
    strokeOpacity?: number;
    strokePosition?: google.maps.StrokePosition;
    strokeWeight?: number;
    visible?: boolean;
    zIndex?: number;
    circleKey?: string;
    mapKey?: string;
    options?: Record<string, unknown>;
}, {
    circleShapePromise: Promise<google.maps.Circle | undefined>;
}, {}, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, {
    click: (value: google.maps.MapMouseEvent) => any;
    dblclick: (value: google.maps.MapMouseEvent) => any;
    drag: (value: google.maps.MapMouseEvent) => any;
    dragend: (value: google.maps.MapMouseEvent) => any;
    dragstart: (value: google.maps.MapMouseEvent) => any;
    mousedown: (value: google.maps.MapMouseEvent) => any;
    mousemove: (value: google.maps.MapMouseEvent) => any;
    mouseout: (value: google.maps.MapMouseEvent) => any;
    mouseover: (value: google.maps.MapMouseEvent) => any;
    mouseup: (value: google.maps.MapMouseEvent) => any;
    center_changed: () => any;
    radius_changed: (value: undefined) => any;
    rightclick: (value: google.maps.MapMouseEvent) => any;
}, string, import('vue').PublicProps, Readonly<{
    center?: google.maps.LatLng | google.maps.LatLngLiteral;
    clickable?: boolean;
    draggable?: boolean;
    editable?: boolean;
    fillColor?: string;
    fillOpacity?: number;
    radius?: number;
    strokeColor?: string;
    strokeOpacity?: number;
    strokePosition?: google.maps.StrokePosition;
    strokeWeight?: number;
    visible?: boolean;
    zIndex?: number;
    circleKey?: string;
    mapKey?: string;
    options?: Record<string, unknown>;
}> & Readonly<{
    onClick?: ((value: google.maps.MapMouseEvent) => any) | undefined;
    onDblclick?: ((value: google.maps.MapMouseEvent) => any) | undefined;
    onDrag?: ((value: google.maps.MapMouseEvent) => any) | undefined;
    onDragend?: ((value: google.maps.MapMouseEvent) => any) | undefined;
    onDragstart?: ((value: google.maps.MapMouseEvent) => any) | undefined;
    onMousedown?: ((value: google.maps.MapMouseEvent) => any) | undefined;
    onMousemove?: ((value: google.maps.MapMouseEvent) => any) | undefined;
    onMouseout?: ((value: google.maps.MapMouseEvent) => any) | undefined;
    onMouseover?: ((value: google.maps.MapMouseEvent) => any) | undefined;
    onMouseup?: ((value: google.maps.MapMouseEvent) => any) | undefined;
    onCenter_changed?: (() => any) | undefined;
    onRadius_changed?: ((value: undefined) => any) | undefined;
    onRightclick?: ((value: google.maps.MapMouseEvent) => any) | undefined;
}>, {
    options: Record<string, unknown>;
    center: google.maps.LatLng | google.maps.LatLngLiteral;
    clickable: boolean;
    draggable: boolean;
    editable: boolean;
    fillColor: string;
    fillOpacity: number;
    radius: number;
    strokeColor: string;
    strokeOpacity: number;
    strokePosition: google.maps.StrokePosition;
    strokeWeight: number;
    visible: boolean;
    zIndex: number;
    circleKey: string;
    mapKey: string;
}, {}, {}, {}, string, import('vue').ComponentProvideOptions, false, {}, any>;
export default _default;
