import { RendererElement, RendererNode, VNode } from 'vue';
declare const _default: import('vue').DefineComponent<{
    collisionBehavior?: google.maps.CollisionBehavior;
    content?: HTMLElement;
    gmpClickable?: boolean;
    gmpDraggable?: boolean;
    position?: google.maps.LatLng | google.maps.LatLngLiteral | google.maps.LatLngAltitude | google.maps.LatLngAltitudeLiteral;
    title?: string;
    zIndex?: number;
    markerKey?: string;
    clusterKey?: string;
    mapKey?: string;
    options?: Record<string, unknown>;
}, {
    VNodeMarkerIcon: VNode<RendererNode, RendererElement, Record<string, any>> | undefined;
    markerPromise: Promise<google.maps.marker.AdvancedMarkerElement | undefined>;
}, {}, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, {
    click: (value: google.maps.MapMouseEvent) => any;
    drag: (value: google.maps.MapMouseEvent) => any;
    dragend: (value: google.maps.MapMouseEvent) => any;
    dragstart: (value: google.maps.MapMouseEvent) => any;
    "gmp-click": (value: google.maps.marker.AdvancedMarkerClickEvent) => any;
    "update:position": (value: {
        lat?: number;
        lng?: number;
    }) => any;
}, string, import('vue').PublicProps, Readonly<{
    collisionBehavior?: google.maps.CollisionBehavior;
    content?: HTMLElement;
    gmpClickable?: boolean;
    gmpDraggable?: boolean;
    position?: google.maps.LatLng | google.maps.LatLngLiteral | google.maps.LatLngAltitude | google.maps.LatLngAltitudeLiteral;
    title?: string;
    zIndex?: number;
    markerKey?: string;
    clusterKey?: string;
    mapKey?: string;
    options?: Record<string, unknown>;
}> & Readonly<{
    onClick?: ((value: google.maps.MapMouseEvent) => any) | undefined;
    onDrag?: ((value: google.maps.MapMouseEvent) => any) | undefined;
    onDragend?: ((value: google.maps.MapMouseEvent) => any) | undefined;
    onDragstart?: ((value: google.maps.MapMouseEvent) => any) | undefined;
    "onGmp-click"?: ((value: google.maps.marker.AdvancedMarkerClickEvent) => any) | undefined;
    "onUpdate:position"?: ((value: {
        lat?: number;
        lng?: number;
    }) => any) | undefined;
}>, {
    options: Record<string, unknown>;
    zIndex: number;
    mapKey: string;
    clusterKey: string;
    position: google.maps.LatLng | google.maps.LatLngLiteral | google.maps.LatLngAltitude | google.maps.LatLngAltitudeLiteral;
    content: HTMLElement;
    markerKey: string;
    collisionBehavior: google.maps.CollisionBehavior;
    gmpClickable: boolean;
    gmpDraggable: boolean;
    title: string;
}, {}, {}, {}, string, import('vue').ComponentProvideOptions, false, {}, any>;
export default _default;
