declare const _default: import('vue').DefineComponent<{
    clickable?: boolean;
    draggable?: boolean;
    editable?: boolean;
    fillColor?: string;
    fillOpacity?: number;
    geodesic?: boolean;
    paths?: google.maps.MVCArray<google.maps.MVCArray<google.maps.LatLng>> | google.maps.MVCArray<google.maps.LatLng> | (google.maps.LatLng | google.maps.LatLngLiteral)[][] | (google.maps.LatLng | google.maps.LatLngLiteral)[];
    strokeColor?: string;
    strokeOpacity?: number;
    strokePosition?: google.maps.StrokePosition;
    strokeWeight?: number;
    visible?: boolean;
    zIndex?: number;
    deepWatch?: boolean;
    polygonKey?: string;
    mapKey?: string;
    options?: Record<string, unknown>;
}, {
    polygonShapePromise: Promise<google.maps.Polygon | undefined>;
}, {}, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, {
    click: (value: google.maps.PolyMouseEvent) => any;
    contextmenu: (value: google.maps.PolyMouseEvent) => any;
    dblclick: (value: google.maps.PolyMouseEvent) => any;
    drag: (value: google.maps.MapMouseEvent) => any;
    dragend: (value: google.maps.MapMouseEvent) => any;
    dragstart: (value: google.maps.MapMouseEvent) => any;
    mousedown: (value: google.maps.PolyMouseEvent) => any;
    mousemove: (value: google.maps.PolyMouseEvent) => any;
    mouseout: (value: google.maps.PolyMouseEvent) => any;
    mouseover: (value: google.maps.PolyMouseEvent) => any;
    mouseup: (value: google.maps.PolyMouseEvent) => any;
    paths_changed: (value: google.maps.MVCArray<google.maps.MVCArray<google.maps.LatLng>>) => any;
}, string, import('vue').PublicProps, Readonly<{
    clickable?: boolean;
    draggable?: boolean;
    editable?: boolean;
    fillColor?: string;
    fillOpacity?: number;
    geodesic?: boolean;
    paths?: google.maps.MVCArray<google.maps.MVCArray<google.maps.LatLng>> | google.maps.MVCArray<google.maps.LatLng> | (google.maps.LatLng | google.maps.LatLngLiteral)[][] | (google.maps.LatLng | google.maps.LatLngLiteral)[];
    strokeColor?: string;
    strokeOpacity?: number;
    strokePosition?: google.maps.StrokePosition;
    strokeWeight?: number;
    visible?: boolean;
    zIndex?: number;
    deepWatch?: boolean;
    polygonKey?: string;
    mapKey?: string;
    options?: Record<string, unknown>;
}> & Readonly<{
    onClick?: ((value: google.maps.PolyMouseEvent) => any) | undefined;
    onContextmenu?: ((value: google.maps.PolyMouseEvent) => any) | undefined;
    onDblclick?: ((value: google.maps.PolyMouseEvent) => any) | undefined;
    onDrag?: ((value: google.maps.MapMouseEvent) => any) | undefined;
    onDragend?: ((value: google.maps.MapMouseEvent) => any) | undefined;
    onDragstart?: ((value: google.maps.MapMouseEvent) => any) | undefined;
    onMousedown?: ((value: google.maps.PolyMouseEvent) => any) | undefined;
    onMousemove?: ((value: google.maps.PolyMouseEvent) => any) | undefined;
    onMouseout?: ((value: google.maps.PolyMouseEvent) => any) | undefined;
    onMouseover?: ((value: google.maps.PolyMouseEvent) => any) | undefined;
    onMouseup?: ((value: google.maps.PolyMouseEvent) => any) | undefined;
    onPaths_changed?: ((value: google.maps.MVCArray<google.maps.MVCArray<google.maps.LatLng>>) => any) | undefined;
}>, {
    options: Record<string, unknown>;
    clickable: boolean;
    draggable: boolean;
    editable: boolean;
    fillColor: string;
    fillOpacity: number;
    strokeColor: string;
    strokeOpacity: number;
    strokePosition: google.maps.StrokePosition;
    strokeWeight: number;
    visible: boolean;
    zIndex: number;
    mapKey: string;
    geodesic: boolean;
    deepWatch: boolean;
    paths: google.maps.MVCArray<google.maps.MVCArray<google.maps.LatLng>> | google.maps.MVCArray<google.maps.LatLng> | (google.maps.LatLng | google.maps.LatLngLiteral)[][] | (google.maps.LatLng | google.maps.LatLngLiteral)[];
    polygonKey: string;
}, {}, {}, {}, string, import('vue').ComponentProvideOptions, false, {}, any>;
export default _default;
