declare const _default: import('vue').DefineComponent<{
    bounds?: google.maps.LatLngBounds | google.maps.LatLngBoundsLiteral;
    clickable?: boolean;
    draggable?: boolean;
    editable?: boolean;
    fillColor?: string;
    fillOpacity?: number;
    strokeColor?: string;
    strokeOpacity?: number;
    strokePosition?: google.maps.StrokePosition;
    strokeWeight?: number;
    visible?: boolean;
    zIndex?: number;
    rectangleKey?: string;
    mapKey?: string;
    options?: Record<string, unknown>;
}, {
    rectangleShapePromise: Promise<google.maps.Rectangle | undefined>;
}, {}, {}, {}, import('vue').ComponentOptionsMixin, import('vue').ComponentOptionsMixin, {
    click: (value: google.maps.PolyMouseEvent) => any;
    contextmenu: (value: google.maps.PolyMouseEvent) => any;
    dblclick: (value: google.maps.PolyMouseEvent) => any;
    drag: (value: google.maps.MapMouseEvent) => any;
    dragend: (value: google.maps.MapMouseEvent) => any;
    dragstart: (value: google.maps.MapMouseEvent) => any;
    mousedown: (value: google.maps.PolyMouseEvent) => any;
    mousemove: (value: google.maps.PolyMouseEvent) => any;
    mouseout: (value: google.maps.PolyMouseEvent) => any;
    mouseover: (value: google.maps.PolyMouseEvent) => any;
    mouseup: (value: google.maps.PolyMouseEvent) => any;
    bounds_changed: () => any;
}, string, import('vue').PublicProps, Readonly<{
    bounds?: google.maps.LatLngBounds | google.maps.LatLngBoundsLiteral;
    clickable?: boolean;
    draggable?: boolean;
    editable?: boolean;
    fillColor?: string;
    fillOpacity?: number;
    strokeColor?: string;
    strokeOpacity?: number;
    strokePosition?: google.maps.StrokePosition;
    strokeWeight?: number;
    visible?: boolean;
    zIndex?: number;
    rectangleKey?: string;
    mapKey?: string;
    options?: Record<string, unknown>;
}> & Readonly<{
    onClick?: ((value: google.maps.PolyMouseEvent) => any) | undefined;
    onContextmenu?: ((value: google.maps.PolyMouseEvent) => any) | undefined;
    onDblclick?: ((value: google.maps.PolyMouseEvent) => any) | undefined;
    onDrag?: ((value: google.maps.MapMouseEvent) => any) | undefined;
    onDragend?: ((value: google.maps.MapMouseEvent) => any) | undefined;
    onDragstart?: ((value: google.maps.MapMouseEvent) => any) | undefined;
    onMousedown?: ((value: google.maps.PolyMouseEvent) => any) | undefined;
    onMousemove?: ((value: google.maps.PolyMouseEvent) => any) | undefined;
    onMouseout?: ((value: google.maps.PolyMouseEvent) => any) | undefined;
    onMouseover?: ((value: google.maps.PolyMouseEvent) => any) | undefined;
    onMouseup?: ((value: google.maps.PolyMouseEvent) => any) | undefined;
    onBounds_changed?: (() => any) | undefined;
}>, {
    bounds: google.maps.LatLngBounds | google.maps.LatLngBoundsLiteral;
    options: Record<string, unknown>;
    clickable: boolean;
    draggable: boolean;
    editable: boolean;
    fillColor: string;
    fillOpacity: number;
    strokeColor: string;
    strokeOpacity: number;
    strokePosition: google.maps.StrokePosition;
    strokeWeight: number;
    visible: boolean;
    zIndex: number;
    mapKey: string;
    rectangleKey: string;
}, {}, {}, {}, string, import('vue').ComponentProvideOptions, false, {}, any>;
export default _default;
